/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   color.c                                            :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/16 18:58:49 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/16 18:58:52 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

t_color color_init(int red, int green, int blue)
{
	t_color c;

	c.red = red;
	c.green = green;
	c.blue = blue;
	return (c);
}

t_color	color_lerp(t_color c1, t_color c2, double step)
{
	t_color	new;
	double	red;
	double	green;
	double	blue;

	red = (double)(c2.red - c1.red) * step + c1.red;
	green = (double)(c2.green - c1.green) * step + c1.green;
	blue = (double)(c2.blue - c1.blue) * step + c1.blue;
	new.red = (int)red;
	new.green = (int)green;
	new.blue = (int)blue;
	return (new);
}

int		color_to_int(t_color c)
{
	return ((c.red << 16) | (c.green << 8) | c.blue);
}

t_color	int_to_color(int c)
{
	t_color new;

	new.blue = c & 0x0000FF;
	new.green = (c >> 8) & 0x0000FF;
	new.red = (c >> 16) & 0x0000FF;
	return (new);
}

int		rainbow(int step, int max_step)
{
	if (step >= 0 && step < max_step / 8)
		return (RED);
	if (step >= max_step / 8 && step <= max_step / 4)
		return (ORANGE);
	if (step >= max_step / 4 && step <= max_step / 8 * 3)
		return (YELLOW);
	if (step >= max_step / 8 * 3 && step <= max_step / 2)
		return (BLUE);
	if (step >= max_step / 2 && step <= max_step / 8 * 5)
		return (VIOLET);
	if (step >= max_step / 8 * 5 && step <= max_step / 8 * 6)
		return (BLACK);
	return (0);
}

//int		rainbow(int step, int max_step)
//{
//	if (step >= 0 && step < max_step / 8)
//		return (color_to_int(
//				color_lerp(int_to_color(RED), int_to_color(ORANGE),
//						   step / max_step / 8)));
//	if (step >= max_step / 8 && step <= max_step / 8 * 2)
//		return (color_to_int(
//				color_lerp(int_to_color(ORANGE), int_to_color(YELLOW),
//						   step / max_step / 8 * 2)));
//	if (step >= max_step / 8 * 2 && step <= max_step / 8 * 3)
//		return (color_to_int(
//				color_lerp(int_to_color(YELLOW), int_to_color(GREEN),
//						   step / max_step / 8 * 3)));
//	if (step >= max_step / 8 * 3 && step <= max_step / 8 * 4)
//		return (color_to_int(
//				color_lerp(int_to_color(GREEN), int_to_color(BLUE),
//						   step / max_step / 8 * 4)));
//	if (step >= max_step / 8 * 4 && step <= max_step / 8 * 5)
//		return (color_to_int(
//				color_lerp(int_to_color(BLUE), int_to_color(VIOLET),
//						   step / max_step / 8 * 5)));
//	if (step >= max_step / 8 * 5 && step <= max_step / 8 * 6)
//		return (color_to_int(
//				color_lerp(int_to_color(VIOLET), int_to_color(BLACK),
//						   step / max_step / 8 * 6)));
//	return (0);
//}
