/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   image_routine.c                                    :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/16 18:59:11 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/16 18:59:12 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

void	new_and_clear_image(t_fractol *fr)
{
	if (fr)
	{
		if (fr->image)
			mlx_destroy_image(fr->mw->mlx, fr->image);
		fr->image = mlx_new_image(fr->mw->mlx, WIDTH, HEIGHT);
		fr->image_data = mlx_get_data_addr(
				fr->image,
				&fr->bpp,
				&fr->line_size,
				&fr->endian);
	}
}

void	put_pixel_to_image(int x, int y, t_color *col, t_fractol *fr)
{
	if (x < 0 || y < 0 || x >= fr->w_width || y >= fr->w_height)
		return ;
	*(int *)((fr->image_data + x * fr->bpp / 8 + y * fr->line_size)) =
			color_to_int(*col);
}
